'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbtalktimer.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode = 1
#Include "Win32API.inc"
#Include "WinINET.inc"

$Ver = "1.4"

#Resource Manifest, 1,    "files\xptheme.xml"
#Resource Icon logo       "images\gbtalktimer.ico"
#Resource Icon xstart     "images\start.ico"
#Resource Icon xreset     "images\reset.ico"
#Resource Icon xcountdown "images\countdown.ico"
#Resource Icon xcountup   "images\countup.ico"
#Resource Icon xsettings  "images\settings.ico"
#Resource Icon xhelp      "images\help.ico"

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDT_Run = 500
   IDT_Reset
   IDT_CountUp
   IDT_CountDown
   IDT_Settings
   IDT_Help

   IDC_Toolbar
   IDC_TimerCounter
   IDC_TimerTimeOfDay
   IDC_Time
   IDC_Alarm

   IDM_EnterCustomTime
   IDM_CreateCustomTime
   IDM_EnterTimeOfDay
   IDM_Sep
   IDM_CountDownAlarm
   IDM_TimeOfDayAlarm
   IDM_Debug
   IDM_UpdateEXE
   IDM_Speak
   IDM_OnTop
   IDM_Repeat
   IDM_BGColor
   IDM_FGColor
   IDM_ResetColor
   IDM_SystemTray
   IDM_TrayQuit
   IDM_TrayRestore

   IDC_DownloadLabel
   IDC_ProgressBar
   IDC_InstallOk
   IDC_InstallCancel
   IDC_InstallCheckBox
   IDC_InstallImage
   IDC_InstallLabel

   IDM_CustomTime
   IDM_Half     = 2030
   IDM_One      = 2060
   IDM_Three    = 2180
   IDM_Five     = 2300
   IDM_Ten      = 2600
   IDM_Thirty   = 3800
End Enum

%WM_Tray   = %WM_User + 1

%CountUp = 1
%CountDown = 0

Global hDlg,hFont,hPopupSettings,hToolbar,hFontAlarm As Dword               'temporary variables
Global ghHook,hBMP,hDebug,hWait,hInstall,hTrayMenu As Dword, Restart, Debug As Long     'temporary variables
Global CountDownAlarm, TimeOfDayAlarm, Run, CountDirection As Long                              'INI values
Global UseCustomTime, CurrentTime, MaxTime, CustomTime As Long, CustomColorList As CustomColors 'INI values
Global TimeOfDay, FontName As WStringZ * %Max_Path, tn As NotifyIconData                        'INI values
Global SysTray,Repeat,Speak,FGColor,BGColor,TalkPoint,OnTop As Long                             'INI values

Function PBMain() As Long
   Local iResult As Long
   Dialog New Pixels, 0, "gbTalkTimer  " + $Ver,300,300,200,160, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   CreateContextMenus
   Control Add Label, hDlg, %IDC_Time,"", 0,60,200,100, %WS_Border Or %SS_Center Or %SS_CenterImage Or %SS_Notify
   Control Add Label, hDlg, %IDC_Alarm,"", 10,65,100,20
   Dialog Show Modal hDlg Call DlgProc
'   Dialog Show Modeless hDlg Call DlgProc
'   Do : Dialog DoEvents To iResult : Loop Until iResult = 0

   If Restart Then
      If IsFile(Exe.Path$ + Exe.Name$ + ".exe.old") Then Kill Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".exe" As Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".new" As Exe.Path$ + Exe.Name$ + ".exe"
      Restart = Shell(Exe.Full$,1)
   End If

End Function

CallBack Function DlgProc() As Long
   Local w,h,iResult As Long, temp$, pt As Point
   Local rc As Rect, nmtb As TBNotify Ptr, P As TooltipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog

         tn.cbsize = SizeOf(tn)
         tn.hwnd   = hDlg
         tn.uid    =  GetModuleHandle(ByVal %NULL)   'g_hinst
         tn.uflags = %nif_icon Or %nif_message Or %nif_tip
         tn.ucallbackmessage = %WM_Tray
         tn.hicon = loadicon(%null,ByVal Mak(Long, %idi_application,0))
         tn.sztip = "gbClipOpen"
         Shell_NotifyIcon %nim_add, tn

         BuildAcceleratorTable
         Graphic Bitmap New 10,10 To hBMP
         Graphic Attach hBMP, 0
         Settings_ini "get"

         Font New FontName, 10, 1 To hFontAlarm
         Control Set Font hDlg, %IDC_Alarm, hFontAlarm
         Control Set Color hDlg, %IDC_Alarm, FGColor, -2

         Control Set Color hDlg, %IDC_Time, FGColor, BGColor
         ManageDebug
         SetFont
         ManageTimeOfDay
         ManageOnTop
         ManageStart
         ManageSystemTray
         SetMenusAndToolbar
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_SystemTray
               SysTray = SysTray Xor 1
               SetMenusAndToolbar
               ManageSystemTray

            Case %IDM_TrayQuit
               Dialog End hDlg

            Case %IDM_TrayRestore
               SysTray = SysTray Xor 1
               SetMenusAndToolbar
               ManageSystemTray

            Case %IdCancel
               iResult = sndPlaySound("", %SND_Async)   'stop once song has started

            Case %IDC_Time
               If Cb.CtlMsg = %STN_Clicked Then
                  Run = Run Xor 1
                  ManageStart
               End If

            Case %IDM_Speak
               Speak = Speak Xor 1
               SetMenusAndToolbar

            Case %IDM_OnTop
               OnTop = OnTop Xor 1
               SetMenusAndToolbar
               ManageOnTop

            Case %IDM_Repeat
               Repeat = Repeat Xor 1
               SetMenusAndToolbar

            Case %IDM_CountDownAlarm
               CountDownAlarm = CountDownAlarm Xor 1
               SetMenusAndToolbar

            Case %IDM_TimeOfDayAlarm
               TimeOfDayAlarm = TimeOfDayAlarm Xor 1
               ManageTimeOfDay
               SetMenusAndToolbar

            Case %IDT_Run
               Run = Run Xor 1
               ManageStart

            Case %IDT_Reset
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CurrentTime = IIf(CountDirection, 0, MaxTime)
               SetFont
               SetMenusAndToolbar

            Case %IDT_CountUp
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CountDirection = %CountUp
               CurrentTime = IIf(CountDirection, 0, MaxTime)
               SetFont
               SetMenusAndToolbar

            Case %IDT_CountDown
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CountDirection = %CountDown
               CurrentTime = IIf(CountDirection, 0, MaxTime)
               SetFont
               SetMenusAndToolbar

            Case %IDM_Debug
               Debug = Debug Xor 1
               ManageDebug

            Case %IDM_UpdateExe
               CheckForEXEUpdates($ver)

            Case %IDM_CustomTime
               UseCustomTime = 1
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CountDirection = %CountDown
               MaxTime = CustomTime
               CurrentTime = CustomTime
               SetFont
               SetMenusAndToolbar

            Case %IDM_Half To %IDM_Thirty
               UseCustomTime = 0
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CountDirection = %CountDown
               MaxTime = Cb.Ctl - 2000
               CurrentTime = Cb.Ctl - 2000
               SetFont
               SetMenusAndToolbar

            Case %IDM_EnterTimeOfDay
               EnterTimeOfDay

            Case %IDM_BGColor
               BGColor = SelectColor(BGColor)
               Control Set Color hDlg, %IDC_Time, FGColor, BGColor
               Control Set Color hDlg, %IDC_Alarm, FGColor, -2
               Control ReDraw hDlg, %IDC_Time
               Control ReDraw hDlg, %IDC_Alarm

            Case %IDM_ResetColor
               FGColor = %Black
               BGColor = %White
               Control Set Color hDlg, %IDC_Time, FGColor, BGColor
               Control Set Color hDlg, %IDC_Alarm, FGColor, -2
               Control ReDraw hDlg, %IDC_Time
               Control ReDraw hDlg, %IDC_Alarm

            Case %IDM_FGColor
               FGColor = SelectColor(FGColor)
               Control Set Color hDlg, %IDC_Time, FGColor, BGColor
               Control Set Color hDlg, %IDC_Alarm, FGColor, -2
               Control ReDraw hDlg, %IDC_Time
               Control ReDraw hDlg, %IDC_Alarm

            Case %IDT_Settings, %IDM_EnterCustomTime
               UseCustomTime = 1
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               SetMaxTime
               SetFont
               SetMenusAndToolbar

            Case %IDM_CreateCustomTime
               UseCustomTime = 1
               Run = 0
               KillTimer hDlg, %IDC_TimerCounter
               CreateCustomInterval
               SetFont
               SetMenusAndToolbar

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbtalktimer.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
         End Select
      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Menu Set Text hPopupSettings, ByCmd %IDM_CountDownAlarm, "Count Down Alarm " + "( " + StoM(MaxTime) + "}"
                       Menu Set Text hPopupSettings, ByCmd %IDM_CustomTime, "Custom " + "( " + StoM(CustomTime) + "}"
                       Menu Set Text hPopupSettings, ByCmd %IDM_EnterTimeOfDay, "Enter Time of Day  " + "( " + TimeOfDay + "}"
                       Menu Set Text hPopupSettings, ByCmd %IDM_TimeOfDayAlarm, "Time of Day Alarm " + "( " + TimeOfDay + "}"
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Run To %IDT_Help
                   Select Case Cb.NmCode
                      Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                   End Select
           End Select
      Case %WM_Timer
         If Debug Then Txt.Print "%WM_Timer"
         Select Case Cb.WParam
            Case %IDC_TimerCounter
               If CountDirection = %CountUp Then
                  'countup
                  Incr CurrentTime
               Else
                  'countdown
                  Decr CurrentTime
                  If CurrentTime = 0 Then
                     Run = 0
                     KillTimer hDlg, %IDC_TimerCounter
                     SetMenusAndToolbar
                     If CountDownAlarm Then
                        If SysTray Then
                           SysTray = 0
                           SetMenusAndToolbar
                           ManageSystemTray
                        End If
                     End If
                     SoundAlarm
                  End If
               End If
               SetFont
               If Speak Then ManageVoice
            Case %IDC_TimerTimeOfDay
               If TimeOfDayAlarm And (TimeOfDay = Time$) Then
                  If SysTray Then
                     SysTray = 0
                     SetMenusAndToolbar
                     ManageSystemTray
                  End If
                  SoundAlarm
               End If
         End Select
      Case %WM_Size
         If Debug Then Txt.Print "%WM_Size"
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_Time, w,h-60
         SetFont
      Case %WM_Tray
         Select Case Cb.LParam
            Case %WM_RButtonDown
               GetCursorPos pt
               TrackPopupMenu hTrayMenu, %TPM_BottomAlign Or %TPM_RightAlign, pt.x, pt.y, 0, hDlg, ByVal %null
               PostMessage hDlg, %WM_Null, 0, 0
            Case %WM_LButtonDblClk
               SysTray = SysTray Xor 1
               ManageSystemTray
               SetMenusAndToolbar
         End Select
       Case %WM_Destroy
         Shell_NotifyIcon %nim_delete, tn
         KillTimer Cb.Hndl, %IDC_TimerCounter
         Graphic Bitmap End
         Font End hFont
         Font End hFontAlarm
         Settings_ini "save"
   End Select
End Function

Sub CreateToolbar
    If Debug Then Txt.Print FuncName$
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xstart"     '1
    ImageList Add Icon hImageList, "xreset"     '2
    ImageList Add Icon hImageList, "xcountup"   '3
    ImageList Add Icon hImageList, "xcountdown" '4
    ImageList Add Icon hImageList, "xsettings"  '5
    ImageList Add Icon hImageList, "xhelp"      '6

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Run,  %TbStyle_Check, " On/Off "
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Reset,  %TbStyle_Button, "Reset"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_CountUp,  %TbStyle_CheckGroup, "   Up   "
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_CountDown,  %TbStyle_CheckGroup, "Down"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Help,  %TbStyle_Button, "Help"

End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Run        : Function = "Toggle Timer On/Off)"
      Case %IDT_Reset      : Function = "Reset and Pause"
      Case %IDT_CountUp    : Function = "Reset, Pause and Set Mode to Count Up"
      Case %IDT_CountDown  : Function = "Reset, Pause and Set Mode to Count Down"
      Case %IDT_Settings   : Function = "Set Count Down Custom Interval"
      Case %IDT_Help       : Function = "Online Help"
   End Select
End Function

Sub CreateContextMenus
   If Debug Then Txt.Print FuncName$

    Menu New PopUp To htraymenu
    Menu Add String, htraymenu, "Restore", %IDM_TrayRestore, %MF_Enabled
    Menu Add String, htraymenu, "Quit", %IDM_TrayQuit, %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "0:30", %IDM_Half, %MF_Enabled
    Menu Add String, hPopupSettings, "1:00", %IDM_One, %MF_Enabled
    Menu Add String, hPopupSettings, "3:00", %IDM_Three, %MF_Enabled
    Menu Add String, hPopupSettings, "5:00", %IDM_Five, %MF_Enabled
    Menu Add String, hPopupSettings, "10:00", %IDM_Ten, %MF_Enabled
    Menu Add String, hPopupSettings, "30:00", %IDM_Thirty, %MF_Enabled
    Menu Add String, hPopupSettings, "Custom", %IDM_CustomTime, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Speak", %IDM_Speak, %MF_Enabled
    Menu Add String, hPopupSettings, "Count Down Alarm", %IDM_CountDownAlarm, %MF_Enabled
    Menu Add String, hPopupSettings, "Time Of Day Alarm", %IDM_TimeOfDayAlarm, %MF_Enabled
    Menu Add String, hPopupSettings, "Repeat Alarm", %IDM_Repeat, %MF_Enabled
    Menu Add String, hPopupSettings, "On Top", %IDM_OnTop, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Enter Custom CountDown Interval (MM:SS)", %IDM_EnterCustomTime, %MF_Enabled
    Menu Add String, hPopupSettings, "Create Custom CountDown Interval From Time of Day", %IDM_CreateCustomTime, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Enter Time of Day (HH:MM:SS)", %IDM_EnterTimeOfDay, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Select Text Color", %IDM_FGColor, %MF_Enabled
    Menu Add String, hPopupSettings, "Select Background Color", %IDM_BGColor, %MF_Enabled
    Menu Add String, hPopupSettings, "Reset Colors To Black && White", %IDM_ResetColor, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Send To System Tray", %IDM_SystemTray, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Online Update", %IDM_UpdateEXE, %MF_Enabled
End Sub

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(6)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B  : ac(c).cmd  = %IDT_Run         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd  = %IDT_Reset       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd  = %IDM_SystemTray: Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd  = %IDT_CountUp     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd  = %IDT_CountDown   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd  = %IDM_Debug       : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub SetMenusAndToolbar
   If Debug Then Txt.Print FuncName$
   Local i As Long
   'Controls
   Control Show State hDlg, %IDC_Alarm, IIf(TimeOfDayAlarm, %SW_Show, %SW_Hide)

   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Run, Run * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CountUp, CountDirection * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CountDown, (CountDirection Xor 1) * %TBState_Checked Or %TBState_Enabled

   'Menus
    Menu Set State hPopupSettings, ByCmd %IDM_CountDownAlarm, CountDownAlarm * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_TimeOfDayAlarm, TimeOfDayAlarm * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_Speak, Speak * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_OnTop, OnTop * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_Repeat, Repeat * (%MFS_Checked Or %MFS_Enabled)

    For i = %IDM_Half To %IDM_Thirty
       Menu Set State hPopupSettings, ByCmd i, %MFS_Enabled
    Next i
    If UseCustomTime Then
       Menu Set State hPopupSettings, ByCmd %IDM_CustomTime, %MFS_Checked Or %MFS_Enabled
    Else
       Menu Set State hPopupSettings, ByCmd %IDM_CustomTime, %MFS_Enabled
       Select Case MaxTime
          Case 30    : Menu Set State hPopupSettings, ByCmd %IDM_Half, %MFS_Checked Or %MFS_Enabled
          Case 60    : Menu Set State hPopupSettings, ByCmd %IDM_One, %MFS_Checked Or %MFS_Enabled
          Case 180   : Menu Set State hPopupSettings, ByCmd %IDM_Three, %MFS_Checked Or %MFS_Enabled
          Case 300   : Menu Set State hPopupSettings, ByCmd %IDM_Five, %MFS_Checked Or %MFS_Enabled
          Case 600   : Menu Set State hPopupSettings, ByCmd %IDM_Ten, %MFS_Checked Or %MFS_Enabled
          Case 1800  : Menu Set State hPopupSettings, ByCmd %IDM_Thirty, %MFS_Checked Or %MFS_Enabled
       End Select
    End If
End Sub

Sub SetFont
   If Debug Then Txt.Print FuncName$
   Local w,h,x,y,FontSize As Long, temp$, hFontG As Dword
   Static OldFontSize As Long
   Control Get Client hDlg, %IDC_Time To w,h
   temp$ = StoM(CurrentTime)
   Font New FontName, 1000, 1 To hFontG
   Graphic Set Font hFontG
   Graphic Text Size temp$ To x,y
   Font End hFontG
   FontSize = 1000/IIf( x/w > y/h , x/(w*0.95) , y/(h*0.95) )
   If FontSize <> OldFontSize Then
      Control Set Text hDlg, %IDC_Time, StoM(CurrentTime)
      Font New FontName, FontSize, 1 To hFont
      Control Set Font hDlg, %IDC_Time, hFont
   Else
      Control Set Text hDlg, %IDC_Time, StoM(CurrentTime)
   End If
   Control Set Text hDlg, %IDC_Alarm, TimeOfDay
   OldFontSize = FontSize
End Sub

Function MtoS(M As String) As Long
   If Debug Then Txt.Print FuncName$
   Function = Val(Parse$(M,":",1))*60 + Val(Parse$(M,":",2))
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub ManageStart
   If Debug Then Txt.Print FuncName$
   If CountDirection = %CountUp Then
      'countup
      If Run = 0 Then KillTimer hDlg, %IDC_TimerCounter
      If Run = 1 Then SetTimer hDlg, %IDC_TimerCounter, 1000, ByVal %NULL
   Else
      'countdown
      If Run = 0 Then KillTimer hDlg, %IDC_TimerCounter
      If Run = 1 Then
         If CurrentTime > 0 Then
            SetTimer hDlg, %IDC_TimerCounter, 1000, ByVal %NULL
         Else
            KillTimer hDlg, %IDC_TimerCounter
            Run = 0
         End If
      End If
   End If
   SetMenusAndToolbar
End Sub

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "320", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "250", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TimeOfDay", "17:00:00", TimeOfDay, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "UseCustomTime", "0", temp, %Max_Path, INIFileName:  UseCustomTime = Val(temp)
      Getprivateprofilestring "All", "CountDownAlarm", "1", temp, %Max_Path, INIFileName:  CountDownAlarm = Val(temp)
      Getprivateprofilestring "All", "TimeOfDayAlarm", "1", temp, %Max_Path, INIFileName:  TimeOfDayAlarm = Val(temp)
      Getprivateprofilestring "All", "Run", "0", temp, %Max_Path, INIFileName:  Run = Val(temp)
      Getprivateprofilestring "All", "CountDirection", "1", temp, %Max_Path, INIFileName:  CountDirection = Val(temp)
      Getprivateprofilestring "All", "CurrentTime", "0", temp, %Max_Path, INIFileName:  CurrentTime = Val(temp)
      Getprivateprofilestring "All", "MaxTime", "300", temp, %Max_Path, INIFileName:  MaxTime = Val(temp)
      Getprivateprofilestring "All", "CustomTime", "10", temp, %Max_Path, INIFileName:  CustomTime = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%White), temp, %Max_Path, INIFileName:  BGColor = Val(temp)
      Getprivateprofilestring "All", "FGColor", Str$(%Black), temp, %Max_Path, INIFileName:  FGColor = Val(temp)
      Getprivateprofilestring "All", "Speak", "0", temp, %Max_Path, INIFileName:  Speak = Val(temp)
      Getprivateprofilestring "All", "OnTop", "0", temp, %Max_Path, INIFileName:  OnTop = Val(temp)
      Getprivateprofilestring "All", "TalkPoint", "11", temp, %Max_Path, INIFileName:  TalkPoint = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "TimeOfDay",TimeOfDay, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "UseCustomTime", (Str$(UseCustomTime)), INIFileName
      WritePrivateProfileString "All", "CountDownAlarm", (Str$(CountDownAlarm)), INIFileName
      WritePrivateProfileString "All", "TimeOfDayAlarm", (Str$(TimeOfDayAlarm)), INIFileName
      WritePrivateProfileString "All", "Run", (Str$(Run)), INIFileName
      WritePrivateProfileString "All", "CountDirection", (Str$(CountDirection)), INIFileName
      WritePrivateProfileString "All", "CurrentTime", (Str$(CurrentTime)), INIFileName
      WritePrivateProfileString "All", "MaxTime", (Str$(MaxTime)), INIFileName
      WritePrivateProfileString "All", "CustomTime", (Str$(CustomTime)), INIFileName
      WritePrivateProfileString "All", "BGColor", (Str$(BGColor)), INIFileName
      WritePrivateProfileString "All", "FGColor", (Str$(FGColor)), INIFileName
      WritePrivateProfileString "All", "Speak", (Str$(Speak)), INIFileName
      WritePrivateProfileString "All", "OnTop", (Str$(OnTop)), INIFileName
      WritePrivateProfileString "All", "TalkPoint", (Str$(TalkPoint)), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), temp, INIFileName
      Next

   End If
End Sub

Sub ManageDebug
   If Debug Then Txt.Print FuncName$
   If Debug Then
      Txt.Window "Debug", 300,300,40,40 To hDebug
      Txt.Print "TXT Window Opened"
   Else
      Txt.End
   End If
End Sub

Sub CheckForEXEUpdates(CurrentVer$)
   If Debug Then Txt.Print FuncName$
   'Ver 2.0 (CheckforUpdates function only)

   'On the server, place
   'myapp.new --> myapp.exe renamed to myapp.new
   'myapp.ver --> version number of myapp.new, such as 1.0

   'CheckForUpdates function does these things
   '    --> downloads myapp.ver, compares it to local app version
   '    --> if user agrees, kill myapp.new then download myapp.new (please wait dialog w/progress bar appears)
   '    --> get appname, position, location from commandline
   '    --> Kill myapp.exe.old
   '   ---> renames myapp.exe as myapp.exe.old
   '   ---> renames myapp.new as myapp.exe
   '   ---> restart myapp.exe (which is the new version)

   Local LocalFilePath, URLSite, URLVerPath, URLFilePath, ServerVer As WStringZ * %Max_Path
   Local w,h,ServerFileSize As Long, Style As Dword, Buffer, AllBytes As String
   Local locX As Long, locY As Long, sizeX As Long, sizeY As Long
   'local information
   LocalFilePath = Exe.Path$ + Exe.Name$ + ".new"   'location to put downloaded new EXE (renamed as NEW) file on local PC

   'server information
   URLSite = "www.garybeene.com"                                                 'server
   URLVerPath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".ver"   'gives version number on server (myapp.ver)
   URLFilePath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".new"  'is the latest EXE (named myapp.new)

   'clear the cache for the .new file
   DeleteURLCacheEntry(LocalFilePath)  '1 = success  clear the cache

   'read the .ver file from the server (not save, just read content into buffer)
   'if cannot get it tell user there was a problem and then exit Sub
   Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
   Tcp Print #1, "GET  " + URLVerPath + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Print #1, ""
   Tcp Recv #1, 4096, ServerVer    'this gets the Header + Body
   Tcp Close #1
   ServerVer = Remain$(ServerVer, $CrLf + $CrLf)   'this returns just the body

   'if ServerVer not newer than local version, tell user and then exit Sub
   Select Case Val(ServerVer)
      Case 0
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox  0, "Update information not available!", "Online Update", %MB_Ok Or %MB_IconExclamation
         Exit Sub
      Case <= Val(CurrentVer$)
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox 0, "You have the latest update!", "Online Update", %MB_Ok Or %MB_IconInformation
         Exit Sub
   End Select

   'server version is now verified as newer than local version
   'ask user for permission to proceed with download
   Style = %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If MessageBox (0, "Update available. Download and install?", "Online Update", Style) = %IdCancel Then Exit Sub

   'before downloading, remove the existing .old and .new files, if they exist
   If IsFile(LocalFilePath) Then Kill LocalFilePath           'kill .new to clear the way

   'Get file size to use in download display status
    Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
    Tcp Print #1, "HEAD  " + URLFilePath + "  HTTP/1.0"
    Tcp Print #1, "" : Tcp Print #1, ""
    Tcp Recv #1, 4096, Buffer : Tcp Close #1
    Buffer = Remain$(Buffer, "Content-Length:")
    ServerFileSize = Val(Extract$(Buffer, $CrLf))

    'Exit Sub if filesize is zero (tell user of the problem)
    If ServerFileSize = 0 Then
       ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox 0, "Download file Not found!", "Online Update", %MB_Ok + %MB_IconExclamation
       Exit Sub
    End If

   'Display a Downloading ... PleaseWait dialog with a download status progress bar
   Dialog Get Client hDlg To w,h
   sizeX = 170 : sizeY = 90
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_Popup To hWait
   Control Add Label, hWait, %IDC_DownloadLabel, $CrLf + "Downloading ... please wait !", 0, 0, sizeX, sizeY, %SS_Center Or %WS_Border
   Control Set Color hWait, %IDC_DownloadLabel, %Black, %White
   Control Add Progressbar, hWait, %IDC_ProgressBar,"", 10,sizeY-40,sizeX-20,20   'bottom of dialog, but on top of label
   Dialog Show Modeless hWait  'no dlg proc required

   'Download the file
   Tcp Open "http" At URLSite As #1 TimeOut 60000   'connect
   If Err Then Beep : Exit Sub
   Tcp Print #1, "GET " & URLFilePath & " HTTP/1.0"      'send the GET request
   Tcp Print #1, ""
   Do                                                              'get bytes until no more available
     Tcp Recv #1, 4096, Buffer
     AllBytes = AllBytes + Buffer
     Progressbar Set Pos hWait, %IDC_ProgressBar, (100*Len(AllBytes)/ServerFileSize)
   Loop While IsTrue Len(Buffer) And IsFalse Err
   Tcp Close #1                     'done, close the connection
   Dialog End hWait                'Remove the download status dialog

   If Len(AllBytes) = 0 Then
      'download failed. tell the user then exit sub
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox 0, "Download of updated version failed!", "Online Update", %MB_Ok Or %MB_IconExclamation
      Exit Sub
   End If

   'Save the file, but first take off the HTTP header from the received bytes
   AllBytes  = Remain$(AllBytes, $CrLf + $CrLf)
   Open LocalFilePath For Binary As #1
   Put$ #1,AllBytes
   Close #1

   'the new application was successfully downloaded
   'Display a "Installation available. proceed? " dialog
   sizeX = 290 : sizeY = 80
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_SysMenu To hInstall
   Control Add Image, hInstall, %IDC_InstallImage, "logo", 10, 10, 50,50, %WS_Border
   Control Add Label, hInstall, %IDC_InstallLabel, "Application is ready to install!", 75,15,270,20
   Control Add Button, hInstall, %IDC_InstallOk,"Install", 75,40,50,25
   Control Add Button, hInstall, %IDC_InstallCancel,"Cancel", 135,40,50,25
   Control Add CheckBox, hInstall, %IDC_InstallCheckBox,"Start on exit", 200,40,150,20
   Control Set Check hInstall, %IDC_InstallCheckBox, 1   'optional (start on exit)
   Dialog Show Modal hInstall Call InstallProc
   Dialog End hInstall
End Sub


CallBack Function InstallProc() As Long
   Select Case Cb.Msg
       Case %WM_Command
          Select Case Cb.Ctl
             Case %IDC_InstallOk
                Control Get Check hInstall, %IDC_InstallCheckBox To Restart
                Dialog End hInstall
                Dialog End hDlg
             Case %IDC_InstallCancel
                Dialog End hInstall
          End Select
   End Select
End Function

Function MsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Sub ReadText (sText As String)
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub

Sub ManageVoice
   If CurrentTime = 0 And CountDownAlarm = 0 Then
      ReadText "Count down completed."
   ElseIf CurrentTime = 0 And CountDownAlarm = 1 Then
      Exit Sub
   ElseIf CurrentTime Mod 60 = 0 Then
      ReadText IIf$(CountDirection, "Counting up at ", "Counting down at ") + Str$(CurrentTime\60) + " minute" + IIf$(CurrentTime\60 > 1, "s","")
   ElseIf CurrentTime < TalkPoint And CountDirection = 0 Then
      ReadText Str$(CurrentTime)
   End If
End Sub

Sub ManageOnTop
   If Debug Then Txt.Print FuncName$
   Local iReturn As Integer, Flags&
   Flags& = %SWP_NOMOVE Or %SWP_NOSIZE
   If OnTop Then
      iReturn = SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, Flags)  'on Top
   Else
      iReturn = SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, Flags) 'not on Top
   End If
End Sub

Sub SetMaxTime
   If Debug Then Txt.Print FuncName$
   Local temp$, w,h As Long
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Set Countdown Interval", StoM(CustomTime), w+40,h+150)
   If Len(temp$) Then
      CustomTime = MtoS(temp$)
      MaxTime = CustomTime
      CurrentTime = CustomTime
      Run = 0
      KillTimer hDlg, %IDC_TimerCounter
      CountDirection = %CountDown
      SetFont
      SetMenusAndToolbar
   End If
End Sub

Sub EnterTimeOfDay
   If Debug Then Txt.Print FuncName$
   Local temp$, w,h As Long
   Local FutureTime, NowTime As IPowerTime
   Let FutureTime = Class "PowerTime"
   Let NowTime = Class "PowerTime"
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Enter Time of Day", TimeofDay, w+40,h+150)
   If Len(temp$) Then TimeOfDay = temp$ : ManageTimeOfDay
End Sub

Sub CreateCustomInterval
   If Debug Then Txt.Print FuncName$
   Local DeltaSeconds,iResult As Long
   Local HH, MM, SS As Long
   Local FutureTime, NowTime As IPowerTime
   Let FutureTime = Class "PowerTime"
   Let NowTime = Class "PowerTime"
      'get
      HH = Val(Parse$(TimeOfDay,":",1))
      MM = Val(Parse$(TimeOfDay,":",2))
      SS = Val(Parse$(TimeOfDay,":",3))
      FutureTime.Now
      FutureTime.NewTime HH,MM,SS
      NowTime.Now
      NowTime.TimeDiff FutureTime, iResult, ByVal 0, ByVal 0, ByVal 0, DeltaSeconds
      If iResult < 0 Then
         CustomTime = DeltaSeconds
         MaxTime = CustomTime
         CurrentTime = CustomTime
         Run = 0
         KillTimer hDlg, %IDC_TimerCounter
         CountDirection = %CountDown
         SetFont
         SetMenusAndToolbar
      Else
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox  0, "Time entered must be later today!", "Set Interval By Time of Day", %MB_Ok Or %MB_IconExclamation
      End If
End Sub

Function StoM(ByVal S As Long) As String
   If Debug Then Txt.Print FuncName$
   Local DDD,HH,MM,SS As Long
   DDD = S \ 86400
   S = S - DDD * 86400
   HH = (S \ 3600)
   S = S - HH * 3600
   MM = (S \ 60)
   SS = S Mod 60
   If DDD Then
      Function = Format$(DDD, "0") + ":" + Format$(HH, "00") + ":" + Format$(MM,"00") + ":" + Format$(SS,"00")
   ElseIf HH Then
      Function = Format$(HH, "0") + ":" + Format$(MM,"00") + ":" + Format$(SS,"00")
   Else
      Function = Format$(MM,"0") + ":" + Format$(SS,"00")
   End If
'   Function = Format$(S\60, "0") + ":" + Format$(S Mod 60,"00")
End Function

Sub SoundAlarm
   Local iResult As Long
   If Repeat Then
      iResult = sndPlaySound("files\alarm.wav", %SND_Async Or %SND_Loop)   'play continuously
   Else
      iResult = sndPlaySound("files\alarm.wav", %SND_Async)   'play once, in background
   End If
End Sub

Sub ManageTimeOfDay
   If Debug Then Txt.Print FuncName$
   Control Set Text hDlg, %IDC_Alarm, TimeOfDay
   Control ReDraw hDlg, %IDC_Alarm
   If TimeOfDayAlarm Then
      SetTimer hDlg, %IDC_TimerTimeOfDay, 1000, ByVal %NULL
   Else
      KillTimer hDlg, %IDC_TimerTimeOfDay
   End If
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then Txt.Print FuncName$
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub ManageSystemTray
   If Debug Then Txt.Print FuncName$
   If SysTray Then
      Dialog Show State hDlg, %SW_Hide
      tn.cbsize = SizeOf(tn)
      tn.hwnd   = hDlg
      tn.uid    =  GetModuleHandle(ByVal %NULL)   'g_hinst
      tn.uflags = %nif_icon Or %nif_message Or %nif_tip
      tn.ucallbackmessage = %WM_Tray
      tn.hicon = loadicon(GetModuleHandle(""),"logo" )
      tn.sztip = "gbTalkTimer"
      Shell_NotifyIcon %nim_add, tn
   Else
      Shell_NotifyIcon %nim_delete, tn
      Dialog Show State hDlg, %SW_Show  ' or %SW_Minimize
   End If
End Sub
